// Operator Demo
#include <stdio.h>

#define FLAG1 1
#define FLAG2 2
#define FLAG3 4

int main(int argc, char* argv[])
{
	// Arithmetic operations
	int i=7, j=4;
	printf("Arithmetic operations:\n\n");
	printf("%d+%d=%d\n",i,j,i+j);
	printf("%d-%d=%d\n",i,j,i-j);
	printf("%d*%d=%d\n",i,j,i*j);
	printf("%d/%d=%d\n",i,j,i/j);
	printf("%d%%%d=%d\n",i,j,i%j);

	int k=1;
	printf("\"k++\":  Before: k=%d",k);
	printf("\tReturn value: %d",k++);
	printf("\t\tAfter: k=%d\n",k);
	k=1; 
	printf("\"++k\":  Before: k=%d",k);
	printf("\tReturn value: %d",++k);
	printf("\t\tAfter: k=%d\n",k);
	k=1; 
	printf("\"k--\":  Before: k=%d",k);
	printf("\tReturn value: %d",k--);
	printf("\t\tAfter: k=%d\n",k);
	k=1; 
	printf("\"--k\":  Before: k=%d",k);
	printf("\tReturn value: %d",--k);
	printf("\t\tAfter: k=%d\n",k);


	// Relational and logical operations
	i=5, j=4;
	printf("\n\nRelational and logical operations:\n\n");
	printf("%d>%d is %s\n",i,j,(i>j)?"true":"false");
	printf("%d<%d is %s\n",i,j,(i<j)?"true":"false");
	printf("%d>=%d is %s\n",i,j,(i>=j)?"true":"false");
	printf("%d<=%d is %s\n",i,j,(i<=j)?"true":"false");
	printf("%d==%d is %s\n",i,j,(i==j)?"true":"false");
	printf("%d!=%d is %s\n",i,j,(i!=j)?"true":"false");
	printf("!(%d!=%d) is %s\n",i,j,(!(i!=j))?"true":"false");
	printf("(%d>=%d)&&(%d==%d) is %s\n",i,j,i,j,((i>=j)&&(i==j))?"true":"false");
	printf("(%d>=%d)||(%d==%d) is %s\n",i,j,i,j,((i>=j)||(i==j))?"true":"false");
	printf("(%d>=%d)&(%d==%d) is %s\n",i,j,i,j,((i>=j)&(i==j))?"true":"false");
	printf("(%d>=%d)|(%d==%d) is %s\n",i,j,i,j,((i>=j)|(i==j))?"true":"false");

	i=4; j=4;
	printf("\n Test whether '&&' is a boolean shortcut operator:");
	printf("\n i=%d   j=%d",i,j);
	printf("\n (4>4)&&(i++==j++) is %s",((4>4)&&(i++==j++))?"true":"false");
	printf("\n i=%d   j=%d",i,j);
	printf("\n The second argument is not evaluated\n -> '&&' is a shortcut operator!\n");

	i=4; j=4;
	printf("\n Test whether '&' is a boolean shortcut operator:");
	printf("\n i=%d   j=%d",i,j);
	printf("\n (4>4)&(i++==j++) is %s",((4>4)&(i++==j++))?"true":"false");
	printf("\n i=%d   j=%d",i,j);
	printf("\n Both arguments are evaluated\n -> '&' is not a shortcut operator!\n (Note: this is consistent with the bitwise operation)");

	// Bitwise operations
	// NOTE: %#x outputs a variable in hexadecimal form with 0x prefixed
	i=0xFF00, j=0xF00F;
	printf("\n\nBitwise operations:\n\n");
	printf("~%#x = %#x\n",i,~i);
	printf("%#x & %#x = %#x\n",i,j,i&j);
	printf("%#x | %#x = %#x\n",i,j,i|j);
	printf("%#x ^ %#x = %#x\n",i,j,i^j);
	printf("%#x << 4 = %#x\n",i,i<<4);
	printf("%#x >> 4 = %#x\n",i,i>>4);

	int myInt=0x000000C3;
	int bitMask = 0x0000000F;			//    11000011 (=195)
	int lowFourBits = myInt & bitMask;	//  & 00001111 (=15)
										//  = 00000011 (=3)
	printf("\nmyInt=%d bitMask=%d lowFourBits=%d\n",myInt, bitMask, lowFourBits);

	int state=FLAG1 | FLAG3;
	if (state & FLAG3) printf("FLAG3 is set");


	return 0;
}
